<template>
  <div
    class="nav flex-column nav-pills text-center mr-5 ml-5 mb-2 mt-0 w-80"
    id="serverPills"
    role="tablist"
    aria-orientation="vertical"
    ref="serverPills"
  >
    <div v-if="serversOnline.length>0" class="alert alert-primary mt-0 mb-2 p-3 p-lg-2" role="alert">
      <h4>Servers Online</h4>
    </div>
    <a
      class="nav-link mb-1 p-3 p-lg-2"
      :class="{'active' : key==0, 'shared':server.userId!=user.id}"
      :id="'v-pills-'+server.id+'-tab'"
      data-toggle="pill"
      :href="'#v-pills-'+server.id"
      role="tab"
      aria-controls="v-pills-home"
      aria-selected="true"
      v-for="(server, key) in serversOnline"
      @click="setActive(server)"
      :key="key"
      :title="server.name"
    >{{server.name }}</a>
    <div
      class="alert d-flex alert-primary mt-3 mb-0 p-3 p-lg-3 pl-3 justify-content-between align-items-center"
      role="alert"
      v-if="serverselected"
    >
      <h5 class="mr-2 p-1">Libraries</h5>
      <span class="p-0 btn" v-if="serverselected.userId==user.id" data-trigger="hover | focus" data-toggle="popover"  data-content="Add new library"  @click="$modal.show('modalNewLibrary')">
        <font-awesome-icon class="ico" color="green" icon="plus"/>
      </span>
    </div>
    <ul class="list-group d-flex list-group-flush mb-4">
      <li
        v-for="(library, key) in libraries"
        :key="key"
        :ref="'lib'+key"
        @click="$emit('changeLibrary',library)"
        :class="{'libraryselected':library==librarySelected}"
        class="btn library list-group-item d-flex justify-content-around text-left p-3 p-lg-2 pl-4"
      >
        <span class="ml-1 p-lg-0 p-1">
          <template v-if="(!isRenaming || isRenaming!=library)">{{library.name}}</template>
          <template v-else-if="isRenaming==library">
            <input
              v-focus
              class="input-border-less-name"
              type="text"
              v-model="newName"
              @blur="isRenaming=false"
              @keyup.enter="renameLibrary(library)"
            >
          </template>
        </span>
        <span class="d-flex ml-auto">
          <span class="btn p-0 mr-1" v-show="library==librarySelected && !isRenaming && serverselected.userId==user.id">
            <font-awesome-icon
              data-toggle="popover"
              data-trigger="focus | hover"
              data-placement="auto"
              data-content="Delete"
              @click.stop="$modal.show('modalConfirm');"
              class="m-0 ico"
              color="firebrick"
              icon="trash-alt"
            />
            <modal-confirm action='delLibrary' @delLibrary="response=>delLibrary(library,response)">
              <template>
                Library <span class="text-danger">{{library.name}}</span> will be removed
              </template>
            </modal-confirm>
          </span>
          <span class="btn p-0 m-0" v-show="library==librarySelected && !isRenaming && serverselected.userId==user.id">
            <font-awesome-icon
              class="m-0 ico"
              color="rgb(5, 5, 110)"
              icon="edit"
              data-trigger="hover"
              data-toggle="popover"
              data-content="Edit"
              @click.stop="isRenaming=library"
            />
          </span>
        </span>
      </li>
    </ul>

    <div v-if="serversOffline.length>0" class="alert alert-dark mt-5 mb-2  p-3 p-lg-2" role="alert">
      <h4>Servers Offline</h4>
    </div>
    <a
      class="nav-link disabled mb-1"
      :id="'v-pills-'+server.id+'-tab'"
      data-toggle="pill"
      href="#v-pills-home"
      role="tab"
      aria-controls="v-pills-home"
      aria-selected="true"
      v-for="(server, key) in serversOffline"
      :key="'off'+key"
      :title="server.name"
    >{{server.name}}</a>
  </div>
</template>

<script>
import modalConfirm from '../modals/ModalConfirm'
const $ = require("jquery");
export default {
  name: "leftPanel",
  props: [
    "serversOffline",
    "serversOnline",
    "libraries",
    "librarySelected",
    "serverselected"
  ],
  components:{
    modalConfirm
  },
  watch: {
    librarySelected: function() {
      if (this.librarySelected) this.newName = this.librarySelected.name;
    }
  },
  data() {
    return {
      isRenaming: false,
      newName: "",
      user: JSON.parse(localStorage.getItem("user"))
    };
  },
  directives: {
    focus: {
      inserted: function(el) {
        el.focus();
      }
    }
  },
  mounted: function() {
    this.$socket.on("resDelLibrary", response => {
      if (response.library) {
        this.$emit("libraryDeleted", response.library);
        this.$toastr.info(
          "Libray " + response.library.name + " deleted correctly",
          "Library deleted",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: 'toast-bottom-right',
          }
        );
      } else {
        this.$toastr.error("Error deleting library", "Error", {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        });
      }
    });
  },
  methods: {
    delLibrary(library,response) {
      if(response){
        $("body")
          .children()
          .popover("hide");
        this.$socket.emit("reqDelLibrary", {
          token: localStorage.getItem("jwt"),
          userId: this.user.id,
          serverId: this.serverselected.id,
          library: library
        });
      }
    },

    renameLibrary(library) {
      this.isRenaming = false;
      library.name = this.newName;
      this.$socket.emit("reqRenameLibrary", {
        token: localStorage.getItem("jwt"),
        userId: this.user.id,
        serverId: this.serverselected.id,
        library: library
      });
    },
    setActive(server) {
      this.$emit("changeServer", server);
    }
  }
};
</script>
<style scoped>
  .shared:link{
    color :grey
  }
 .shared:link.shared.active{
   color: white
  }
  .shared.active{
  background-color: grey
  }
  .ico{
    font-size: 2vh
  }
</style>



